

# BatchDeleteDocument
<a name="API_BatchDeleteDocument"></a>

Asynchronously deletes one or more documents added using the `BatchPutDocument` API from an Amazon Q Business index.

You can see the progress of the deletion, and any error messages related to the process, by using CloudWatch.

## Request Syntax
<a name="API_BatchDeleteDocument_RequestSyntax"></a>

```
POST /applications/applicationId/indices/indexId/documents/delete HTTP/1.1
Content-type: application/json

{
   "dataSourceSyncId": "string",
   "documents": [ 
      { 
         "documentId": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_BatchDeleteDocument_RequestParameters"></a>

The request uses the following URI parameters.

 ** [applicationId](#API_BatchDeleteDocument_RequestSyntax) **   <a name="qbusiness-BatchDeleteDocument-request-uri-applicationId"></a>
The identifier of the Amazon Q Business application.  
Length Constraints: Fixed length of 36.  
Pattern: `[a-zA-Z0-9][a-zA-Z0-9-]{35}`   
Required: Yes

 ** [indexId](#API_BatchDeleteDocument_RequestSyntax) **   <a name="qbusiness-BatchDeleteDocument-request-uri-indexId"></a>
The identifier of the Amazon Q Business index that contains the documents to delete.  
Length Constraints: Fixed length of 36.  
Pattern: `[a-zA-Z0-9][a-zA-Z0-9-]{35}`   
Required: Yes

## Request Body
<a name="API_BatchDeleteDocument_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [dataSourceSyncId](#API_BatchDeleteDocument_RequestSyntax) **   <a name="qbusiness-BatchDeleteDocument-request-dataSourceSyncId"></a>
The identifier of the data source sync during which the documents were deleted.  
Type: String  
Length Constraints: Fixed length of 36.  
Pattern: `[a-zA-Z0-9][a-zA-Z0-9-]{35}`   
Required: No

 ** [documents](#API_BatchDeleteDocument_RequestSyntax) **   <a name="qbusiness-BatchDeleteDocument-request-documents"></a>
Documents deleted from the Amazon Q Business index.  
Type: Array of [DeleteDocument](API_DeleteDocument.md) objects  
Required: Yes

## Response Syntax
<a name="API_BatchDeleteDocument_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "failedDocuments": [ 
      { 
         "dataSourceId": "string",
         "error": { 
            "errorCode": "string",
            "errorMessage": "string"
         },
         "id": "string"
      }
   ]
}
```

## Response Elements
<a name="API_BatchDeleteDocument_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [failedDocuments](#API_BatchDeleteDocument_ResponseSyntax) **   <a name="qbusiness-BatchDeleteDocument-response-failedDocuments"></a>
A list of documents that couldn't be removed from the Amazon Q Business index. Each entry contains an error message that indicates why the document couldn't be removed from the index.   
Type: Array of [FailedDocument](API_FailedDocument.md) objects

## Errors
<a name="API_BatchDeleteDocument_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
 You don't have access to perform this action. Make sure you have the required permission policies and user accounts and try again.  
HTTP Status Code: 403

 ** ConflictException **   
You are trying to perform an action that conflicts with the current status of your resource. Fix any inconsistencies with your resources and try again.    
 ** message **   
The message describing a `ConflictException`.  
 ** resourceId **   
The identifier of the resource affected.  
 ** resourceType **   
The type of the resource affected.
HTTP Status Code: 409

 ** InternalServerException **   
An issue occurred with the internal server used for your Amazon Q Business service. Wait some minutes and try again, or contact [Support](http://aws.amazon.com/contact-us/) for help.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The application or plugin resource you want to use doesn’t exist. Make sure you have provided the correct resource and try again.    
 ** message **   
The message describing a `ResourceNotFoundException`.  
 ** resourceId **   
The identifier of the resource affected.  
 ** resourceType **   
The type of the resource affected.
HTTP Status Code: 404

 ** ThrottlingException **   
The request was denied due to throttling. Reduce the number of requests and try again.  
HTTP Status Code: 429

 ** ValidationException **   
The input doesn't meet the constraints set by the Amazon Q Business service. Provide the correct input and try again.    
 ** fields **   
The input field(s) that failed validation.  
 ** message **   
The message describing the `ValidationException`.  
 ** reason **   
The reason for the `ValidationException`.
HTTP Status Code: 400

## See Also
<a name="API_BatchDeleteDocument_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/qbusiness-2023-11-27/BatchDeleteDocument) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/qbusiness-2023-11-27/BatchDeleteDocument) 